#ifndef ATOMIC_ITEMS_SERIALIZATION_H
#define ATOMIC_ITEMS_SERIALIZATION_H

#include <iostream>
#include "item.h"
#include "atomic_items.h"

#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>

namespace boost {
  namespace serialization{
    template<class Archive>
    void serialize ( Archive& ar, 
                     Item& aItem,
                     const unsigned int aVersion ) 
    {   
      std::cout << "serializing Item" << std::endl;
      ar & aItem.a;
    }   
  
    template<class Archive>
    void serialize ( Archive& ar, 
                     AtomicItem& aItem,
                     const unsigned int aVersion ) 
    {   
      ar & boost::serialization::base_object<Item>(aItem); 
      std::cout << "serializing AtomicItem" << std::endl;
      ar & aItem.b;
    }   
  
    template<class Archive>
    void serialize ( Archive& ar, 
                     BooleanItem& aItem,
                     const unsigned int aVersion ) 
    {   
      ar & boost::serialization::base_object<AtomicItem>(aItem); 
      std::cout << "serializing BooleanItem" << std::endl;
      ar & aItem.c;
    }   
  
  }
}

#endif
